/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#ifndef CCAMERA_H
#define CCAMERA_H

#include<math.h>                          // Math header that allows us to use cos() and sin().

#define UP              0.01f             // Forward speed.
#define DOWN            -0.01f            // Backward speed.
#define LEFT            0.03f             // Left speed.
#define RIGHT           -0.03f            // Right speed.
#define STRAFE_LEFT     -0.01f            // Left straft speed.
#define STRAFE_RIGHT    0.01f             // Right straft speed.


class CCamera
{
   public:
      CCamera();

      void SetCamera(float x, float y, float z,
                     float xv, float yv, float zv,
                     float xu, float yu, float zu);

      void MoveCamera(float direction);
      void UpdateCamera(float xDir, float yDir,
                        float zDir, float dir);
      void StrafeCam(float direction);
      void CalculateStrafe();
      void RotateCamera(float AngleDir, float xSpeed,
                        float ySpeed, float zSpeed);
      void RotateByMouse(int mousePosX, int mousePosY,
                         int midX, int midY);

      float xPos, yPos, zPos;                         // Camera position.
      float xView, yView, zView;                      // Look at position.
      float xUp, yUp, zUp;                            // Up direction.
      float xStrafe, yStrafe, zStrafe;                // Strafe direction.
      float currentRotationAngle;                     // Keeps us from going too far up or down.
};

#endif


// Copyright October 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com